#!/usr/bin/env python
#-*- encoding: utf-8 -*-
"""
texdep.py
Get the dependencies of a TeX file.

Copyright (c) 2009 Pierre "delroth" Bourdon <delroth@gmail.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import re
import sys

INCLUDE = re.compile(r'^\s*\\(include[a-z]*|input)(?:\[.*?\])?\{(.+?)\}.*$')

DEPS = {}

FILES = sys.argv[1:]

while FILES:
    texfile = FILES.pop()
    if texfile in DEPS:
        continue
    DEPS[texfile] = set()
    fd = open(texfile)
    for line in fd:
        m = INCLUDE.match(line)
        if m is None:
            continue
        typ, fn = m.groups()
        if typ == 'input':
            fn += '.tex'
        DEPS[texfile].add(fn)
        if fn.endswith('.tex'):
            FILES.append(fn)

print '.depend: %s' % ' '.join(DEPS.iterkeys())
for target, deps in DEPS.iteritems():
    print '%s: %s' % (target.replace('.tex', '.pdf'), ' '.join(deps))
    print '%s: %s' % (target, ' '.join(deps))
