/*
 * Implements the BIOS memory handling primitives, like memset, memcmp, etc.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "memory.h"
#include "../psx/interpreter.h"
#include "../psx/memory.h"

#include <stdio.h>
#include <string.h>

void psx_bios_memset(uint32_t* GPR)
{
    uint8_t* where = psx_mem_ram_ptr(GPR[A0] & (RAM_SIZE - 1));

    printf("where = %08X, a1 = %08X, a2 = %08X\n", GPR[A0], GPR[A1], GPR[A2]);

    memset(where, GPR[A1], GPR[A2]);

    puts("OK !");

    GPR[V0] = GPR[A0];
}
