/*
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "printf.h"
#include "../psx/interpreter.h"
#include "../psx/memory.h"

void psx_bios_strlen(uint32_t* GPR)
{
    uint32_t n = 0;
    uint32_t string_addr = GPR[A0];

    while (psx_mem_read_8(string_addr) != '\0')
    {
        n += 1;
        string_addr += 1;
    }

    GPR[V0] = n;
}
