/*
 * Contains the table of all the BIOS syscalls.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "memory.h"
#include "pad.h"
#include "printf.h"
#include "random.h"
#include "strlen.h"
#include "table.h"

#include <stdlib.h>

#define ENTRY(id, func) [id] = psx_bios_##func,

bios_func psx_bios_table[3][0xFF] =
{
    /* AO */
    {
        ENTRY(0x1B, strlen)
        ENTRY(0x2B, memset)
        ENTRY(0x2F, rand)
        ENTRY(0x30, srand)
        ENTRY(0x3F, printf)
    },

    /* B0 */
    {
        ENTRY(0x14, pad_stop)
        ENTRY(0x15, pad_init)
    },

    /* C0 */
    {
        NULL
    }
};
