/*
 * Handles address adaptations.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PSX_ADDRESS_H_
# define __PSX_ADDRESS_H_

# include "globals.h"

# include <stdint.h>

static inline uint32_t adapt_j_address(uint32_t) __attribute__((pure));
static inline uint32_t adapt_branch_address(uint32_t) __attribute__((pure));
static inline uint32_t adapt_pc_to_off(uint32_t) __attribute__((pure));

/* Adapt addresses contained in the instructions */
static inline uint32_t adapt_j_address(uint32_t instr_addr)
{
    return (t_seg_addr & 0xF0000000) + (instr_addr << 2);
}

static inline uint32_t adapt_branch_address(uint32_t instr_addr)
{
    return pc + ((int16_t)instr_addr) * 4;
}

/* Adapt PC value */
static inline uint32_t adapt_pc_to_off(uint32_t pc)
{
    return (pc - t_seg_addr) >> 2;
}

#endif
