/*
 * Declares all the global values used in the PSX execution engine.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PSX_GLOBALS_H_
# define __PSX_GLOBALS_H_

# include <stdint.h>

/* All these things are defined in the code outputted by the translator */

extern uint8_t t_seg[];
extern uint32_t t_seg_addr;
extern uint32_t t_seg_size;

extern uint32_t s_seg_addr;

extern uint32_t init_gp;
extern uint32_t pc;

/* General purpose registers */
extern uint32_t GPR[32];

/* Integer multiplier registers */
extern struct
{
    uint32_t hi, lo;
} IMR;

/* Number of executed cycles */
extern uint32_t cycles;

void psx_exec_one(void);

#endif
