/*
 * Handles hardware mapped registers access.
 * 
 * Approximately the same API as the memory access module.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PSX_HARDWARE_H_
# define __PSX_HARDWARE_H_

# include <stdint.h>

/* Set by main.c, depending on the command line arguments */
extern int log_unhandled_hw;

uint8_t psx_hardware_read_8(uint16_t addr);
uint16_t psx_hardware_read_16(uint16_t addr);
uint32_t psx_hardware_read_32(uint16_t addr);

void psx_hardware_write_8(uint16_t addr, uint8_t data);
void psx_hardware_write_16(uint16_t addr, uint16_t data);
void psx_hardware_write_32(uint16_t addr, uint32_t data);

#endif
