/*
 * Functions to provide info/error messages to the user.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

static void psx_real_message(FILE* stream, const char* format, va_list va)
{
    vfprintf(stream, format, va);
}

void psx_message(const char* format, ...)
{
    va_list va;

    va_start(va, format);
    psx_real_message(stdout, format, va);
    va_end(va);
}

void psx_fail(const char* format, ...)
{
    va_list va;

    va_start(va, format);
    psx_real_message(stderr, format, va);
    va_end(va);

    abort();
}
