/*
 * CPU/SPU plugin communication.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PSX_SPU_H_
# define __PSX_SPU_H_

# include <stdint.h>

extern int (*psx_spu_init)(void);
extern int (*psx_spu_shutdown)(void);
extern int (*psx_spu_open)(void);
extern int (*psx_spu_close)(void);
extern uint16_t (*psx_spu_read_register)(uint32_t);
extern void (*psx_spu_write_register)(uint32_t, uint16_t);

void psx_spu_load(void);
void psx_spu_unload(void);

#endif
