(*
 * Implements R3000 instructions in AST form in order to translate them to
 * LLVM bytecode.
 *
 * Copyright (c) 2009-2010 Pierre "delroth" Bourdon <delroth@gmail.com>
 *
 * This file is part of Meta-morphosis.
 *
 * Meta-morphosis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Meta-morphosis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Meta-morphosis.  If not, see <http://www.gnu.org/licenses/>.
 *)

type translation_context = {
    ctx : Llvm.llcontext ;
    b : Llvm.llbuilder ;
    m : Llvm.llmodule ;
    gpr : Llvm.llvalue ;
    imr : Llvm.llvalue ;
    pc : Llvm.llvalue ;
    i32_type : Llvm.lltype ;
    jump : Llvm.llvalue ;
    mem : Memory.t ;
    i : int ;
    f : Psx_file.t ;
    endblock : Llvm.llbasicblock
}

val code_for_instr : translation_context -> R3000_decoder.instr -> unit

(* true if the compiled code depends on PC *)
val depends_on_pc : R3000_decoder.instr -> bool
